
evFrame = CreateFrame("frame")
evFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
evFrame:RegisterEvent("ADDON_LOADED")
evFrame:RegisterEvent("PLAYER_LOGOUT")
evFrame:RegisterEvent("CHAT_MSG_ADDON")
evFrame:RegisterEvent("BN_CHAT_MSG_ADDON")
evFrame:RegisterEvent('CHALLENGE_MODE_MAPS_UPDATE')
evFrame:RegisterEvent('GET_ITEM_INFO_RECEIVED')
evFrame:SetScript("OnEvent",function(self,event,arg1,arg2,arg3,arg4)
    if event == "ADDON_LOADED" and arg1 == "WeekKeys" then
        kPlayer.ResetAllData()
        kPlayer:GetAllData()
        kPlayer:GetID()
        WeekKeysDB = WeekKeysDB or {}
        WeekKeysDB.Settings = WeekKeysDB.Settings or {}
        if WeekKeysDB.Settings["pkeyslink"] == nil then
            WeekKeysDB.Settings["pkeyslink"] = false
        end
        if WeekKeysDB.Settings["pkeyslink"] == true then
            evFrame:RegisterEvent("CHAT_MSG_PARTY")
            evFrame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
        end

        C_MythicPlus.RequestRewards()
        if C_MythicPlus.IsWeeklyRewardAvailable() then
            evFrame:RegisterEvent("CHAT_MSG_LOOT")
        elseif WeekKeysDB.Character[kPlayer.ID] then
            WeekKeysDB.Character[kPlayer.ID].reward = nil
        end
       -- evFrame:UnregisterEvent("ADDON_LOADED")
        --"request"
        --C_ChatInfo.SendAddonMessage("AngryKeystones","Schedulerequest","PARTY")
        if (IsInGuild()) then
            C_ChatInfo.SendAddonMessage("WeekKeys","request","GUILD")
            for a,b in pairs(WeekKeysDB.Character) do
                if kPlayer.faction == b.faction then
                    C_ChatInfo.SendAddonMessage("WeekKeys", "update "..b.name..":"..b.realm..":"..b.colored..":"..b.ilvl..":"..b.record..":"..(b.keyID or "")..":"..(b.keyLevel or "")..":"..b.faction, "GUILD")
                end
            end
        end
        if WeekKeysDB["MainFramePos"] then
            local db = WeekKeysDB["MainFramePos"]
            WeekFrame:SetPoint(db["point"],db["xOfs"],db["yOfs"])
        end
        --[[
        local i = 1
        while C_BattleNet.GetFriendAccountInfo(i) do
            local friend = C_BattleNet.GetFriendAccountInfo(i)
            local id = friend.gameAccountInfo.gameAccountID
            local battleTag = friend.battleTag
            WeekKeys.friends = WeekKeys.friends or {}
            WeekKeys.friends[id] = battleTag
        end]]
    elseif event == "ADDON_LOADED" and arg1 == "Blizzard_ChallengesUI" then
        C_MythicPlus.RequestRewards()
        hooksecurefunc(ChallengesKeystoneFrame,"Show",WeekKeys.SlotKeystone)
    elseif event == 'GET_ITEM_INFO_RECEIVED' then
        if WeekFrame.CorruptNames[arg1] ~= nil then
            local itemname, itemlink = GetItemInfo(arg1)
            local _,corrup = strsplit(":",itemname)
            WeekFrame.CorruptNames[arg1] = corrup or ""
            WeekFrame.CorruptLinks[arg1] = itemlink
        end
    elseif event == "PLAYER_ENTERING_WORLD" then
        C_MythicPlus.RequestRewards()
    elseif event == "PLAYER_LOGOUT" then
        kPlayer:Save()
    elseif event == "CHAT_MSG_ADDON" then
        kPlayer.GetMessage(arg1,arg2,arg3,arg4)
    elseif event == "CHAT_MSG_LOOT" then
        C_Timer.After(1,function()
            C_MythicPlus.RequestRewards()
         --   if not C_MythicPlus.IsWeeklyRewardAvailable() then
         --       evFrame:UnregisterEvent("CHAT_MSG_LOOT")
         --       kPlayer:GetKeyData()
         --       kPlayer:Save()
         --       WeekKeysDB.Character[kPlayer.ID].reward = nil
         --   end
        end)
    elseif event == "BN_CHAT_MSG_ADDON" then
        --"prefix", "text", "channel", senderID
        kPlayer.BN_Message(arg1,arg2,arg4)
    elseif event == 'CHALLENGE_MODE_MAPS_UPDATE' then
        --print("triggered")
        if not C_MythicPlus.IsWeeklyRewardAvailable() and  WeekKeysDB.Character[kPlayer.ID] then
            WeekKeysDB.Character[kPlayer.ID].reward = nil
        end
        kPlayer:GetKeyData()
        kPlayer:Save()
    elseif (event == "CHAT_MSG_PARTY" or  event == "CHAT_MSG_PARTY_LEADER") then
        if arg1 == "!keys" then
            for container = 0, 4 do
                for slot=1, GetContainerNumSlots(container) do
                    local _, _, _, _, _, _, slotLink, _, _, _ = GetContainerItemInfo(container, slot)
                    if slotLink and slotLink:match("|Hkeystone:") then
                        SendChatMessage("WeekKeys "..slotLink,"party")
                    end
                end
            end
        end
    end
end)

